using System;
using System.Windows.Forms;
using System.Drawing;
using System.Globalization;
using System.Runtime.InteropServices;

namespace BurningShipFractal
{
    static class Program
    {
        /// <summary>
        /// The main entry point for the application.
        /// </summary>
        [DllImport("GDI32.dll")]
        public static extern bool BitBlt(int hdcDest, int nXDest, int nYDest, int nWidth, int nHeight, int hdcSrc, int nXSrc, int nYSrc, int dwRop);
        [DllImport("GDI32.dll")]
        public static extern int CreateCompatibleBitmap(int hdc, int nWidth, int nHeight);
        [DllImport("GDI32.dll")]
        public static extern int CreateCompatibleDC(int hdc);
        [DllImport("GDI32.dll")]
        public static extern bool DeleteDC(int hdc);
        [DllImport("GDI32.dll")]
        public static extern bool DeleteObject(int hObject);
        [DllImport("GDI32.dll")]
        public static extern int GetDeviceCaps(int hdc, int nIndex);
        [DllImport("GDI32.dll")]
        public static extern int SelectObject(int hdc, int hgdiobj);
        public static Image screen;
        // Screensaver mode or exe mode?
        public static bool isScreensaver;
        [STAThread]
        static void Main(string[] args)
        {
            isScreensaver = !Application.ExecutablePath.EndsWith(".exe");
            if (args.Length > 0)
            {
                // Get the 2 character command line argument
                string arg = args[0].ToLower(CultureInfo.InvariantCulture).Trim().Substring(0, 2);
                switch (arg)
                {
                    case "/c":
                        // Show the options dialog
                        ShowOptions();
                        break;
                    case "/p":
                        // Don't do anything for preview
                        break;
                    case "/s":
                        // Show screensaver form
                        ShowScreenSaver();
                        break;
                    default:
                        MessageBox.Show("Invalid command line argument :" + arg, "Invalid Command Line Argument", MessageBoxButtons.OK, MessageBoxIcon.Error);
                        break;
                }
            }
            else
            {
                // If no arguments were passed in, show the screensaver
                ShowScreenSaver();
            }
        }


        static void ShowOptions()
        {
            //OptionsForm optionsForm = new OptionsForm();
            //Application.Run(optionsForm);
            MessageBox.Show("Sorry, but this screensaver has no user configurable options at this time.","No Options");
        }

        static void ShowScreenSaver()
        {
            // Grab the screen
            screen = getScreen();
            // bug user
            if (!isScreensaver) { MessageBox.Show("To exit this application, type a Q at any time after this message closes.", "Important"); }
            ScreenSaverForm screenSaver = new ScreenSaverForm();
            Application.Run(screenSaver);
        }

                public static Image getScreen()
        {
            int hdcSrc = User32.GetWindowDC(User32.GetDesktopWindow()),
            hdcDest = Program.CreateCompatibleDC(hdcSrc),
            hBitmap = Program.CreateCompatibleBitmap(hdcSrc,
            Program.GetDeviceCaps(hdcSrc, 8), Program.GetDeviceCaps(hdcSrc, 10)); Program.SelectObject(hdcDest, hBitmap);
            Program.BitBlt(hdcDest, 0, 0, Program.GetDeviceCaps(hdcSrc, 8),
            Program.GetDeviceCaps(hdcSrc, 10), hdcSrc, 0, 0, 0x00CC0020);
            Bitmap bmp = new Bitmap(Image.FromHbitmap(new IntPtr(hBitmap)),
            Image.FromHbitmap(new IntPtr(hBitmap)).Width,
            Image.FromHbitmap(new IntPtr(hBitmap)).Height);
            cleanup(hBitmap, hdcSrc, hdcDest);
            return (Image)bmp;
        }
        private static void cleanup(int hBitmap, int hdcSrc, int hdcDest)
        {
            User32.ReleaseDC(User32.GetDesktopWindow(), hdcSrc);
            Program.DeleteDC(hdcDest);
            Program.DeleteObject(hBitmap);
        }
        public static class User32
        {
            [DllImport("User32.dll")]
            public static extern int GetDesktopWindow();
            [DllImport("User32.dll")]
            public static extern int GetWindowDC(int hWnd);
            [DllImport("User32.dll")]
            public static extern int ReleaseDC(int hWnd, int hDC);
        }
    }
}