using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.IO;
using System.Windows.Forms;
using System.Threading;

namespace BurningShipFractal
{
    partial class ScreenSaverForm : Form
    {
        // Keep track of whether the screensaver has become active.
        private bool isActive = false;


        // An object to make locking work better (I hope
        public static object lockbox = "bl";
        Random rand = new Random();

        // Background image - we'll be updatng this constantly
        private Bitmap background = (Bitmap)Program.screen;

        // Keep track of the location of the mouse
        private Point mouseLocation;

        // Nasty variables ;D
        int i, j, k, kmax = 100;
        double dcx, dcy, dxy;
        double value;
        double cx, cy, xi, yi, xip1, yip1;

        // Which color do we replace!?
        int argb = 0; // 0 r, 1 g, 2 b



        public ScreenSaverForm()
        {
            InitializeComponent();

            SetupScreenSaver();

            StartDrawingThread();

        }

        private void StartDrawingThread()
        {
            Thread theThread = new Thread(new ThreadStart(doDrawMethod));
            theThread.Start();
        }

        private void doDrawMethod()
        {
            while (true)
            {
                for (j = 0; j < Bounds.Height; j++)
                {
                    cy = dcy + (j - Bounds.Height / 2.0) * dxy / (double)Bounds.Height;

                    for (i = 0; i < Bounds.Width; i++)
                    {
                        cx = dcx + (i - Bounds.Width / 2.0) * dxy / (double)Bounds.Width;

                        xi = 0;
                        yi = 0;
                        for (k = 0; k < kmax; k++)
                        {
                            xip1 = xi * xi - yi * yi - cx;
                            yip1 = 2.0 * Math.Abs(xi * yi) - cy;
                            xi = xip1;
                            yi = yip1;
                            if (xi * xi + yi * yi > 40)
                                break;
                        }
                        value = Math.Sqrt((double)k / (double)kmax);
                        value *= value;
                        lock (lockbox)
                        {
                            if (argb == 0)
                            {
                                background.SetPixel(i, j, Color.FromArgb((int)(value * 255.0), background.GetPixel(i, j).G, background.GetPixel(i, j).B));
                            }
                            else if (argb == 1)
                            {
                                background.SetPixel(i, j, Color.FromArgb(background.GetPixel(i, j).R, (int)(value * 255.0), background.GetPixel(i, j).B));
                            }
                            else
                            {
                                background.SetPixel(i, j, Color.FromArgb(background.GetPixel(i, j).R, background.GetPixel(i, j).G, (int)(value * 255.0)));
                            }
                        }
                    }
                    Invalidate();
                }
                Invalidate();
                // if we get here we'll need to reset these
                dcx = .3 + .0001 * rand.Next(1, 1999);
                dcy = .90 + .000001 * rand.Next(1, 999);
                dxy = (double)rand.Next(1, 1000000000) * .0000000001;
                argb = rand.Next(0, 3);
            }
        }
        
        /// <summary>
        /// Set up the main form as a full screen screensaver.
        /// </summary>
        private void SetupScreenSaver()
        {
            // Use double buffering to improve drawing performance
            //this.SetStyle(ControlStyles.OptimizedDoubleBuffer | ControlStyles.UserPaint | ControlStyles.AllPaintingInWmPaint, true);
            // Capture the mouse
            this.Capture = true;

            //set center and world

            dcx = .3 + .0001 * rand.Next(1, 1999);
            dcy = .90 + .000001 * rand.Next(1, 999);
            dxy = (double)rand.Next(1, 1000000000) * .0000000001;

            argb = rand.Next(0, 3);


            // Set the application to full screen mode and hide the mouse
            Cursor.Hide();
            Bounds = Screen.PrimaryScreen.Bounds;
            for (int i = 0; i < Screen.AllScreens.Length; i++) {
                Bounds = Rectangle.Union(Bounds,Screen.AllScreens[i].Bounds);
            }
            //background = new Bitmap(Screen.PrimaryScreen.Bounds.Width, Screen.PrimaryScreen.Bounds.Height);
            WindowState = FormWindowState.Maximized;
            ShowInTaskbar = false;
            //DoubleBuffered = true;
            //BackgroundImageLayout = ImageLayout.Stretch;
        }

        private void ScreenSaverForm_MouseMove(object sender, MouseEventArgs e)
        {
            if (Program.isScreensaver)
            {
                // Set IsActive and MouseLocation only the first time this event is called.
                if (!isActive)
                {
                    mouseLocation = MousePosition;
                    isActive = true;
                }
                else
                {
                    // If the mouse has moved significantly since first call, close.
                    if ((Math.Abs(MousePosition.X - mouseLocation.X) > 10) ||
                        (Math.Abs(MousePosition.Y - mouseLocation.Y) > 10))
                    {
                        Close();
                    }
                }
            }
        }

        private void ScreenSaverForm_KeyDown(object sender, KeyEventArgs e)
        {
            if (Program.isScreensaver)
            {
                Close();
            }
            else if (e.KeyData == Keys.Q)
            {
                Close();
            }

        }

        private void ScreenSaverForm_MouseDown(object sender, MouseEventArgs e)
        {
            if (Program.isScreensaver)
            {
                Close();
            }
        }

        protected override void OnPaintBackground(PaintEventArgs e)
        {
            // Draw the current background image stretched to fill the full screen
                lock (lockbox)
                {
                    e.Graphics.DrawImage(background, 0, 0);
                }

            // e.Graphics.DrawString("Current Line: " + j+"/"+Bounds.Height, new Font("sans serif", 12), Brushes.Gainsboro, new PointF(900, 900));
        }

        protected override void OnPaint(PaintEventArgs e)
        {
           
        }

        private void ScreenSaverForm_FormClosing(object sender, FormClosingEventArgs e)
        {
            System.Environment.Exit(System.Environment.ExitCode);
        }

    }
}
